`G_E.Duplicated` <-
function(GD,GM,Y,NE,QTN.position,SAME=FALSE){
if(NE==1) stop 

#taxa_GD=as.character(GD[,1])
X=as.matrix(GD[,-1])
n_marker=ncol(X)
n_individual=nrow(X)
store_map=GM
position=QTN.position
MATRIX_DIAG=diag(1,NE*n_individual)
matrix_diag=diag(1,NE)[,1:(NE-1)]
n=nrow(MATRIX_DIAG)
m=ncol(MATRIX_DIAG)
store=NULL
one=as.character(Y[,1])
map=NULL
posi=NULL
diag_orig=diag(1,n_individual)
diag_add=diag_orig

#GM
for(i in 1:2)
{
SNP.name=paste(as.character(store_map[,1]),"_",i,sep="")
chrom=as.numeric(GM[,2])+max(as.numeric(GM[,2]))*(i-1)
store_map[,1]=SNP.name
store_map[,2]=chrom

if(i==1) map=store_map
if(i!=1) map=rbind(map,store_map)

position=position+n_marker
posi=append(posi,position)
}
#GD  
for(i in 1:(NE-1))
{
    AA_matrix=X
    AA_matrix[AA_matrix==1]=2
    AA_matrix[AA_matrix==0]=1
    AA_matrix[AA_matrix==2]=0
    AT_matrix=X
    AT_matrix[AT_matrix==2]=0
    TT_matrix=X
    TT_matrix[TT_matrix==1]=0
    TT_matrix[TT_matrix==2]=1

col_store=MATRIX_DIAG[,(i*n_individual-(n_individual-1)):(i*n_individual)]
if(SAME)
{
diag_inter=diag(1,n_individual)
diag_inter=rbind(diag_inter,diag_inter)
col_store=diag_inter
}

#run big data this code will be faster
#X01_matrix=cbind(AA_matrix,AT_matrix)
#col_store=kronecker(matrix_diag,X01_matrix)

AAcol_store=col_store%*%AA_matrix
ATcol_store=col_store%*%AT_matrix
TTcol_store=col_store%*%TT_matrix

col_store=cbind(AAcol_store,ATcol_store)
colnames(col_store)=map[,1]
#########rm one col to set independent
store=cbind(store,col_store)
diag_orig=rbind(diag_orig,diag_add)
}

add_GD=diag_orig%*%X
colnames(GD)[1]="taxa"
return(list(addGD=cbind(as.data.frame(one),add_GD),interGD=cbind(as.data.frame(one),store),addGM=GM,interGM=map,Y=Y,QTN.position=posi))

}#end function    

